package dynamicallyfiltermdlovapp.view.backing;

import oracle.adf.model.BindingContext;
import oracle.adf.view.rich.event.LaunchPopupEvent;

import oracle.binding.BindingContainer;

import oracle.jbo.ViewCriteria;
import oracle.jbo.ViewCriteriaManager;
import oracle.jbo.ViewCriteriaRow;
import oracle.jbo.uicli.binding.JUCtrlListBinding;

public class SecondTryFilter
{
	public void onSecondTryInputListOfValuesLaunchPopup(LaunchPopupEvent launchPopupEvent)
	{
		// see https://blogs.oracle.com/jdevotnharvest/entry/how_to_dynamically_filter_model
		BindingContext bctx = BindingContext.getCurrent();
		BindingContainer bindings = bctx.getCurrentBindingsEntry();
		// see http://java.net/jira/browse/ADFEMG-36
		//FacesCtrlLOVBinding lov = 
		//	(FacesCtrlLOVBinding)bindings.get("DepartmentId");
		JUCtrlListBinding lov = (JUCtrlListBinding)bindings.get("DepartmentId");
		ViewCriteriaManager vcm = 
			lov.getListIterBinding().getViewObject().getViewCriteriaManager();
		//make sure the view criteria is cleared
		vcm.removeViewCriteria(vcm.DFLT_VIEW_CRITERIA_NAME);
		//create a new view criteria
		ViewCriteria vc = 
			new ViewCriteria(lov.getListIterBinding().getViewObject());
		//use the default view criteria name
		//"__DefaultViewCriteria__"
		vc.setName(vcm.DFLT_VIEW_CRITERIA_NAME);
		//create a view criteria row for all queryable attributes
		ViewCriteriaRow vcr = new ViewCriteriaRow(vc);
		//for this sample I set the query filter to DepartmentId 60. 
		//You may determine it at runtime by reading it from a managed bean
		//or binding layer 
		vcr.setAttribute("DepartmentId", 60);
		System.out.println("SecondTryFilter.onSecondTryInputListOfValuesLaunchPopup() : vcr = " + vcr.toString());
		//also note that the view criteria row consists of all attributes 
		//that belong to the LOV list view object, which means that you can
		//filter on multiple attributes
		vc.addRow(vcr);
		lov.getListIterBinding().getViewObject().applyViewCriteria(vc);
	}
}
